import AppHeader from "@/components/AppHeader";
import ButtonSaveHeader from "@/components/buttonSaveHeader";
import ImageUser from "@/components/imageNew";
import ImageWithLabel from "@/components/imageWithLabel";
import InputSearch from "@/components/inputSearch";
import Text from '@/components/Text';
import { ConstEnv } from "@/constants/ConstEnv";
import Styles from "@/constants/Styles";
import { apiAddMemberDiscussionGeneral, apiGetDiscussionGeneralOne, apiGetUser } from "@/lib/api";
import { setUpdateDiscussionGeneralDetail } from "@/lib/discussionGeneralDetail";
import { useAuthSession } from "@/providers/AuthProvider";
import { useTheme } from "@/providers/ThemeProvider";
import { AntDesign } from "@expo/vector-icons";
import { router, Stack, useLocalSearchParams } from "expo-router";
import { useEffect, useState } from "react";
import { Pressable, SafeAreaView, ScrollView, View } from "react-native";
import Toast from "react-native-toast-message";
import { useDispatch, useSelector } from "react-redux";

type Props = {
   idUser: string,
   name: string,
   img: string
}

export default function AddMemberDiscussionDetail() {
   const dispatch = useDispatch()
   const update = useSelector((state: any) => state.discussionGeneralDetailUpdate)
   const { token, decryptToken } = useAuthSession()
   const { colors } = useTheme();
   const { id } = useLocalSearchParams<{ id: string }>()
   const [dataOld, setDataOld] = useState<Props[]>([])
   const [data, setData] = useState<Props[]>([])
   const [idGroup, setIdGroup] = useState('')
   const [selectMember, setSelectMember] = useState<any[]>([])
   const [search, setSearch] = useState('')
   const [loading, setLoading] = useState(false)

   async function handleLoad() {
      try {
         const hasil = await decryptToken(String(token?.current))
         const response = await apiGetDiscussionGeneralOne({ id: id, user: hasil, cat: 'anggota' })
         setDataOld(response.data)
         const responseGroup = await apiGetDiscussionGeneralOne({ id: id, user: hasil, cat: 'detail' })
         setIdGroup(responseGroup.data.idGroup)
      } catch (error) {
         console.error(error)
      }
   }

   async function handleLoadMember() {
      const hasil = await decryptToken(String(token?.current))
      const response = await apiGetUser({ user: hasil, active: "true", search: search, group: String(idGroup) })
      setData(response.data.filter((i: any) => i.idUserRole != 'supadmin'))
   }


   useEffect(() => {
      handleLoad()
   }, []);


   useEffect(() => {
      handleLoadMember()
   }, [search])

   function onChoose(val: string, label: string, img?: string) {
      if (selectMember.some((i: any) => i.idUser == val)) {
         setSelectMember(selectMember.filter((i: any) => i.idUser != val))
      } else {
         setSelectMember([...selectMember, { idUser: val, name: label, img }])
      }
   }

   async function handleAddMember() {
      try {
         setLoading(true)
         const hasil = await decryptToken(String(token?.current))
         const response = await apiAddMemberDiscussionGeneral({ id: id, data: { user: hasil, member: selectMember } })
         if (response.success) {
            Toast.show({ type: 'small', text1: 'Berhasil menambahkan anggota', })
            dispatch(setUpdateDiscussionGeneralDetail(!update))
            router.back()
         } else {
            Toast.show({ type: 'small', text1: response.message, })
         }
      } catch (error: any) {
         console.error(error);
         const message = error?.response?.data?.message || "Gagal menambahkan anggota"

         Toast.show({ type: 'small', text1: message })
      } finally {
         setLoading(false)
      }
   }


   return (
      <>
         <Stack.Screen
            options={{
               // headerLeft: () => <ButtonBackHeader onPress={() => { router.back() }} />,
               headerTitle: 'Tambah Anggota Diskusi',
               headerTitleAlign: 'center',
               // headerRight: () => (
               //    <ButtonSaveHeader
               //       category="update"
               //       disable={selectMember.length == 0 || loading ? true : false}
               //       onPress={() => {
               //          handleAddMember()
               //       }}
               //    />
               // )
               header: () => (
                  <AppHeader
                     title="Tambah Anggota Diskusi"
                     showBack={true}
                     onPressLeft={() => router.back()}
                     right={
                        <ButtonSaveHeader
                           category="update"
                           disable={selectMember.length == 0 || loading ? true : false}
                           onPress={() => {
                              handleAddMember()
                           }}
                        />
                     }
                  />
               )
            }}
         />
         <View style={[Styles.p15, Styles.flex1, { backgroundColor: colors.background }]}>
            <InputSearch onChange={setSearch} value={search} />

            {
               selectMember.length > 0
                  ?
                  <View>
                     <ScrollView horizontal style={[Styles.mb10, Styles.pv10]} showsHorizontalScrollIndicator={false}>
                        {
                           selectMember.map((item: any, index: any) => (
                              <ImageWithLabel
                                 key={index}
                                 label={item.name}
                                 src={`${ConstEnv.url_storage}/files/${item.img}`}
                                 onClick={() => onChoose(item.idUser, item.name, item.img)}
                              />
                           ))
                        }
                     </ScrollView>
                  </View>

                  :
                  <Text style={[Styles.textDefault, Styles.pv05, Styles.textCenter, { color: colors.dimmed }]}>Tidak ada member yang dipilih</Text>
            }
            <ScrollView
               showsVerticalScrollIndicator={false}
            >

               {
                  data.length > 0 ?
                     data.map((item: any, index: any) => {
                        const found = dataOld.some((i: any) => i.idUser == item.id)
                        return (
                           <Pressable
                              key={index}
                              style={[Styles.itemSelectModal, { borderColor: colors.icon + '20' }]}
                              onPress={() => {
                                 !found && onChoose(item.id, item.name, item.img)
                              }}
                           >
                              <View style={[Styles.rowItemsCenter]}>
                                 <ImageUser src={`${ConstEnv.url_storage}/files/${item.img}`} border />
                                 <View style={[Styles.ml10]}>
                                    <Text style={[Styles.textDefault]}>{item.name}</Text>
                                    {
                                       found && <Text style={[Styles.textInformation, { color: colors.dimmed }]}>sudah menjadi anggota</Text>
                                    }
                                 </View>
                              </View>
                              {
                                 selectMember.some((i: any) => i.idUser == item.id) && <AntDesign name="check" size={20} color={colors.text} />
                              }
                           </Pressable>
                        )
                     }
                     )
                     :
                     <Text style={[Styles.textDefault, Styles.textCenter]}>Tidak ada data</Text>
               }
            </ScrollView>
         </View>
      </>
   )
}